// Wild Magic Source Code
// David Eberly
// http://www.geometrictools.com
// Copyright (c) 1998-2007
//
// This library is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or (at
// your option) any later version.  The license is available for reading at
// either of the locations:
//     http://www.gnu.org/copyleft/lgpl.html
//     http://www.geometrictools.com/License/WildMagicLicense.pdf
//
// Version: 4.0.0 (2006/06/28)

#include "RandomController.h"
using namespace Wm4;

WM4_IMPLEMENT_RTTI(Wm4,RandomController,PointController);
WM4_IMPLEMENT_STREAM(RandomController);
WM4_IMPLEMENT_DEFAULT_STREAM(RandomController,PointController);
WM4_IMPLEMENT_DEFAULT_NAME_ID(RandomController,PointController);

//----------------------------------------------------------------------------
RandomController::RandomController ()
{
}
//----------------------------------------------------------------------------
void RandomController::UpdatePointMotion (float)
{
    Polypoint* pkPoints = StaticCast<Polypoint>(m_pkObject);

    VertexBuffer* pkVB = pkPoints->VBuffer;
    int iVQuantity = pkVB->GetVertexQuantity();
    for (int i = 0; i < iVQuantity; i++)
    {
        float* afPos = pkVB->PositionTuple(i);
        for (int j = 0; j < 3; j++)
        {
            afPos[j] += 0.01f*Mathf::SymmetricRandom();
            if (afPos[j] > 1.0f)
            {
                afPos[j] = 1.0f;
            }
            else if (afPos[j] < -1.0f)
            {
                afPos[j] = -1.0f;
            }
        }
    }

    pkVB->Release();
}
//----------------------------------------------------------------------------
